跳至主要内容

与 Angular 的集成

提示

本指南假设您已熟悉 Angular 的概念和模式。如需了解背景知识,请参考 Angular documentation。

DHTMLX Kanban 与 Angular 兼容。完整代码示例可在 GitHub 上查看。

创建项目​

信息

在创建项目之前,请先安装 Angular CLI 和 Node.js。

以下命令使用 Angular CLI 创建一个新的 my-angular-kanban-app 项目:

ng new my-angular-kanban-app
备注

在出现提示时,禁用服务端渲染(SSR)和静态站点生成(SSG/Prerendering),以使项目与本指南保持一致。

该命令会安装所有必要工具,无需额外运行其他命令。

安装依赖​

进入新创建的应用目录:

cd my-angular-kanban-app

使用 yarn 包管理器安装依赖并启动开发服务器:

yarn
yarn start

应用将会在本地地址(例如 http://localhost:3000)运行。

创建 Kanban​

停止开发服务器并安装 Kanban 包。

步骤 1. 安装包​

下载 试用版 Kanban 包,并按照 README 文件中的步骤进行操作。试用版可使用 30 天。

步骤 2. 创建组件​

创建一个用于挂载 Kanban 和 Toolbar 的 Angular 组件。创建 src/app/kanban/ 文件夹,并在其中添加 kanban.component.ts 文件。

导入源文件​

打开 kanban.component.ts 并导入 Kanban 源文件。导入路径取决于所使用的包版本:

  • 对于从本地文件夹安装的 PRO 版本:
import { Kanban, Toolbar } from 'dhx-kanban-package';
  • 对于试用版:
import { Kanban, Toolbar } from '@dhx/trial-kanban';

本教程使用 Kanban 的试用版。

设置容器并初始化 Kanban​

要显示带有 Toolbar 的 Kanban,需要设置两个容器并调用构造函数。以下代码片段定义了组件模板、引用容器并创建实例:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // 在 "app.component.ts" 文件中以 <kanban /> 形式使用的模板名
styleUrls: ["./kanban.component.css"], // 引入 css 文件
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
// 初始化 Toolbar 容器
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// 初始化 Kanban 容器
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
// 初始化 Kanban 组件
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

// 初始化 Toolbar 组件
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置属性
});
}

ngOnDestroy(): void {
this._kanban.destructor(); // 销毁 Kanban
this._toolbar.destructor(); // 销毁 Toolbar
}
}

添加样式​

为 Kanban 和容器添加样式。在 src/app/kanban/ 目录下创建 kanban.component.css 文件:

kanban.component.css
/* 导入 Kanban 样式 */
@import "@dhx/trial-kanban/dist/kanban.css";

/* 为初始页面指定样式 */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}

/* 为 Kanban 和 Toolbar 容器指定样式 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* 为 Kanban 容器指定样式 */
.widget {
height: calc(100% - 56px);
}

加载数据​

要填充 Kanban,需要提供一组数据。在 src/app/kanban/ 目录下创建 data.ts 文件:

data.ts
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

打开 kanban.component.ts,导入数据集,并在 ngOnInit() 中将数据属性传入 Kanban 配置对象:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // 初始化数据属性
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // 应用列数据
cards, // 应用卡片数据
rows, // 应用行数据
rowKey: "type",
// 其他配置属性
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置属性
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

也可以在创建实例后,通过 ngOnInit() 中的 setConfig() 或 parse() 方法加载数据:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // 初始化数据属性
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置属性
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置属性
});

// 通过 setConfig() 或 parse() 方法应用数据
this._kanban.setConfig({
columns,
cards,
rows
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

Kanban 组件现已可以使用。当该元素渲染时,Kanban 会初始化并加载数据。有关支持的配置属性的完整列表,请参阅 Kanban API 参考。

事件处理​

用户在 Kanban 中的操作会触发事件。通过监听事件可以响应特定操作。完整列表请参阅 Kanban 事件参考。

打开 kanban.component.ts 并扩展 ngOnInit() 方法:

kanban.component.ts
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}

ngOnDestroy(): void {
this._kanban.destructor();
}

步骤 3. 将 Kanban 添加到应用中​

要在应用中注册 KanbanComponent,请打开 src/app/app.component.ts 并替换默认代码:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}

在 src/app/ 目录下创建 app.module.ts 并声明 KanbanComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";

@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

打开 src/main.ts 并替换现有代码:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

运行应用,在页面上查看已填充数据的 Kanban 看板。

在 Angular 应用中初始化的 DHTMLX Kanban 看板,包含已填充的列和卡片

在 GitHub 上查看完整项目。

跳至主要内容

与 React 集成

提示

本指南假定您已熟悉 React 的基本概念和模式。如需了解相关背景知识,请参考 React 官方文档。

DHTMLX Kanban 支持与 React 集成。完整代码示例可在 GitHub 查看。

创建项目​

信息

在创建项目之前,请先安装 Vite(可选)和 Node.js。

创建一个基础的 React 项目(或 React + Vite)。将项目命名为 my-react-kanban-app:

npx create-react-app my-react-kanban-app

安装依赖​

进入新创建的应用目录:

cd my-react-kanban-app

使用以下任一包管理器安装依赖并启动开发服务器:

yarn
yarn start
  • 使用 npm:
npm install
npm run dev

应用会在本地服务器地址上运行(例如 http://localhost:3000)。

创建 Kanban​

停止开发服务器并安装 Kanban 包。

步骤 1. 安装包​

下载 试用版 Kanban 包,并按照 README 文件中的步骤操作。试用版可使用 30 天。

步骤 2. 创建组件​

创建一个将 Kanban 添加到应用中的 React 组件。在 src/ 目录下新建一个文件,命名为 Kanban.jsx。

导入源文件​

打开 Kanban.jsx 并导入 Kanban 源文件。导入路径取决于所用的包版本:

  • 使用从本地文件夹安装的 PRO 版本:
Kanban.jsx
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';

如果包附带压缩版源文件,请将 CSS 文件导入为 kanban.min.css。

  • 使用试用版:
Kanban.jsx
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";

本教程使用 Kanban 的试用版。

设置容器并初始化 Kanban​

要在页面上显示带有 Toolbar 的 Kanban,需要创建两个容器并调用相应的构造函数。以下代码片段在 useEffect() 中绑定 ref 并实例化组件:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // 引入 Kanban 样式

export default function KanbanComponent(props) {
let toolbar_container = useRef(); // 初始化 Toolbar 容器
let kanban_container = useRef(); // 初始化 Kanban 容器

useEffect(() => {
// 初始化 Kanban 组件
const kanban = new Kanban(kanban_container.current, {});

// 初始化 Toolbar 组件
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // 提供 Kanban 内部 API
// 其他配置项
});

return () => {
kanban.destructor(); // 销毁 Kanban
toolbar.destructor(); // 销毁 Toolbar
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

添加样式​

在项目的主 CSS 文件中为 Kanban 及其容器添加样式:

index.css
/* specify styles for initial page */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

加载数据​

要向 Kanban 填充数据,需要提供一个数据集。在 src/ 目录下新建 data.js 文件:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

打开 App.js,导入数据集,并将数据作为 props 传递给新创建的 <Kanban/> 组件:

App.js
import Kanban from "./Kanban";
import { getData } from "./data";

function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}

export default App;

打开 Kanban.jsx,将 props 应用到 Kanban 配置对象中:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // 应用列数据
cards: props.cards, // 应用卡片数据
rows: props.rows, // 应用行数据
rowKey: "type",
// 其他配置项
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// 其他配置项
});

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

另外,也可以在创建实例后,在 useEffect() 中使用 setConfig() 或 parse() 加载数据:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

let columns = props.columns;
let cards = props.cards;
let rows = props.rows;

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// 其他配置项
});

kanban.setConfig({ columns, cards, rows });
// 或 kanban.parse({ columns, cards, rows });

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Kanban 组件现已准备就绪。当元素渲染时,Kanban 会随数据一起初始化。完整的配置属性列表请参见 Kanban API 参考。

事件处理​

用户在 Kanban 中的操作会触发事件。通过监听事件可以对特定操作作出响应。完整列表请参见 Kanban 事件参考。

打开 Kanban.jsx,扩展 useEffect() 调用:

Kanban.jsx
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});

return () => {
kanban.destructor();
};
}, []);
// ...

运行应用,即可在页面上查看填充了数据的 Kanban 看板。

在 React 应用中初始化的 DHTMLX Kanban 看板,包含已填充的列和卡片

完整项目可在 GitHub 查看。

跳至主要内容

与 Svelte 集成

提示

本指南假设您已熟悉 Svelte 的概念和模式。如需了解相关背景,请参阅 Svelte documentation。

DHTMLX Kanban 与 Svelte 兼容。完整的代码示例可在 GitHub 上找到。

创建项目​

信息

在创建项目之前,请先安装 Vite(可选)和 Node.js。

通过以下两种方式之一创建 Svelte 项目:

  • 使用 SvelteKit - 推荐
  • 使用 Svelte 和 Vite(不使用 SvelteKit)- 运行:
npm create vite@latest

详细信息请参阅 Svelte documentation。

安装依赖​

将项目命名为 my-svelte-kanban-app,并进入应用目录:

cd my-svelte-kanban-app

使用以下任一包管理器安装依赖并启动开发服务器:

yarn
yarn start
  • 使用 npm:
npm install
npm run dev

应用将在本地地址运行(例如 http://localhost:3000)。

创建 Kanban​

停止开发服务器并安装 Kanban 包。

步骤 1. 安装包​

下载 试用版 Kanban 包,并按照 README 文件中的步骤操作。试用版可使用 30 天。

步骤 2. 创建组件​

创建一个用于挂载 Kanban 和 Toolbar 的 Svelte 组件。在 src/ 目录下新建 Kanban.svelte 文件。

导入源文件​

打开 Kanban.svelte 并导入 Kanban 源文件。导入路径取决于所用的包版本:

  • 使用从本地文件夹安装的 PRO 版本时:
Kanban.svelte
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

如果包附带压缩后的源文件,请将 CSS 文件导入为 kanban.min.css。

  • 使用试用版时:
Kanban.svelte
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

本教程使用 Kanban 的试用版。

设置容器并初始化 Kanban​

要显示带有 Toolbar 的 Kanban,需创建两个容器并调用相应的构造函数。以下代码片段在 onMount() 中绑定容器并实例化组件:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

let toolbar_container, kanban_container; // initialize containers for Kanban and Toolbar
let kanban, toolbar;

onMount(() => {
// initialize the Kanban component
kanban = new Kanban(kanban_container, {})

// initialize the Toolbar component
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})
});

onDestroy(() => {
kanban.destructor(); // destroy Kanban
toolbar.destructor(); // destroy Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

加载数据​

要向 Kanban 填充数据,需提供一组数据集。在 src/ 目录下创建 data.js 文件:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

打开 App.svelte,导入数据集,并将数据作为 props 传递给新的 <Kanban/> 组件:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { cards, columns, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

打开 Kanban.svelte,将传入的 props 应用到 Kanban 配置对象中:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// other configuration properties
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

或者,在创建实例后,在 onMount() 中使用 setConfig() 或 parse() 加载数据:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})

kanban.setConfig({ columns, cards, rows });
// or kanban.parse({ columns, cards, rows });
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Kanban 组件现已就绪。当元素渲染时,Kanban 会使用数据进行初始化。完整的支持配置属性列表请参阅 Kanban API 参考。

事件处理​

用户在 Kanban 中的操作会触发事件。通过监听事件来响应特定操作。完整列表请参阅 Kanban 事件参考。

打开 Kanban.svelte,扩展 onMount() 回调:

Kanban.svelte
<script>
// ...
let kanban;

onMount(() => {
kanban = new Kanban(kanban_container, {})

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});

onDestroy(() => {
kanban.destructor();
});
</script>

// ...

步骤 3. 将 Kanban 添加到应用​

要注册组件,打开 App.svelte 并替换默认代码:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { columns, cards, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

运行应用,在页面上查看已填充数据的 Kanban 看板。

在 Svelte 应用中初始化的 DHTMLX Kanban 看板,包含已填充的列和卡片

完整项目请参见 GitHub。

跳至主要内容

与 Vue 集成

提示

本指南假定您已熟悉 Vue 的基本概念和模式。如需了解背景知识,请参阅 Vue 3 文档。

DHTMLX Kanban 与 Vue 兼容。Vue 3 的完整代码示例可在 GitHub 上获取。

创建项目​

信息

在创建项目之前,请先安装 Node.js。

以下命令将创建一个新的 Vue 项目:

npm create vue@latest

该命令会运行 create-vue,即官方的 Vue 项目脚手架工具。详细信息请参考 Vue.js 快速开始。

将项目命名为 my-vue-kanban-app。

安装依赖​

进入应用目录:

cd my-vue-kanban-app

使用以下任一包管理器安装依赖并启动开发服务器:

yarn
yarn start // 或 yarn dev
  • 使用 npm:
npm install
npm run dev

应用将在本地服务器地址上运行(例如 http://localhost:3000)。

创建 Kanban​

停止开发服务器并安装 Kanban 包。

步骤 1. 安装包​

下载 试用版 Kanban 包,并按照 README 文件中的步骤操作。试用版可使用 30 天。

步骤 2. 创建组件​

创建一个挂载 Kanban 和 Toolbar 的 Vue 组件。在 src/components/ 目录下新建 Kanban.vue 文件。

导入源文件​

打开 Kanban.vue 并导入 Kanban 的源文件。导入路径取决于所用包的版本:

  • 使用从本地文件夹安装的 PRO 版本:
Kanban.vue
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

如果包附带压缩后的源文件,请将 CSS 文件导入为 kanban.min.css。

  • 使用试用版:
Kanban.vue
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

本教程使用 Kanban 的试用版。

设置容器并初始化 Kanban​

要显示带有 Toolbar 的 Kanban,需要创建两个容器并调用相应的构造函数。以下代码片段在 mounted() 中绑定 refs 并实例化组件:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
mounted() {
// 初始化 Kanban 组件
this.kanban = new Kanban(this.$refs.kanban_container, {});

// 初始化 Toolbar 组件
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api, // 提供 Kanban 内部 API
// 其他配置项
});
},

unmounted() {
this.kanban.destructor(); // 销毁 Kanban
this.toolbar.destructor(); // 销毁 Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

添加样式​

在项目的主 CSS 文件中为 Kanban 及其容器添加样式:

main.css
/* 设置初始页面样式 */
html,
body,
#app { /* 确保使用 #app 作为根容器 */
height: 100%;
padding: 0;
margin: 0;
}

/* 设置 Kanban 和 Toolbar 容器样式 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* 设置 Kanban 容器样式 */
.widget {
height: calc(100% - 56px);
}

加载数据​

要向 Kanban 填充数据,需要提供数据集。在 src/ 目录下创建 data.js 文件:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

打开 App.vue 并导入数据集。通过内部的 data() 方法初始化数据,然后将数据作为 props 传递给新创建的 <Kanban/> 组件:

App.vue
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";

export default {
components: { Kanban },
data() {
const { columns, cards, rows } = getData();
return {
columns,
cards,
rows
};
}
};
</script>

<template>
<Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>

打开 Kanban.vue,将 props 应用于 Kanban 的配置对象:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
cards: this.cards,
columns: this.columns,
rows: this.rows,
rowKey: "type",
// 其他配置项
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// 其他配置项
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

或者,在创建实例后通过 mounted() 中的 setConfig() 或 parse() 加载数据:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// 其他配置项
});

this.kanban.setConfig({
cards: this.cards,
columns: this.columns,
rows: this.rows
});

},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Kanban 组件现已就绪。当元素渲染时,Kanban 将使用数据完成初始化。有关支持的配置属性的完整列表,请参阅 Kanban API 参考。

事件处理​

用户在 Kanban 中的操作会触发事件。监听事件以响应特定操作。完整列表请参阅 Kanban 事件参考。

打开 Kanban.vue 并扩展 mounted() 方法:

Kanban.vue
<script>
// ...
export default {
// ...
mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {});

this.kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
},

unmounted() {
this.kanban.destructor();
}
}
</script>

// ...

运行应用,在页面上查看加载了数据的 Kanban 看板。

在 Vue 应用中初始化的 DHTMLX Kanban 看板,包含已填充的列和卡片

在 GitHub 上查看完整项目。